Subject: bug#49415: ‘Internal compiler error: Segmentation fault’ when building aarch64-linux-gnu cross-compiler [core-updates]

From: Ludovic Courtès <[email-masked]>
Date: Tue, 06 Jul 2021 12:13:16 +0200

Hi,

Maxime Devos <[email-masked]> skribis:

> While testing a patch re-introducing %build-inputs when cross-compiling
> (probably irrelevant to the build failure though), I encountered an ICE
> (internal compiler error).  I checked 'dmesg'; it is not an OOM.
> I believe I encountered similar errors in the past, though they disappeared
> when I retried the build, so this looks like a non-determenistic build
> failure.

[...]

> g++ -fno-PIE -c   -g -O2 -DIN_GCC  -DCROSS_DIRECTORY_STRUCTURE   -fno-exceptions -fno-rtti -fasynchronous-unwind-tables -W -Wall -Wno-narrowing -Wwrite-strings -Wcast-qual -Wno-error=format-diag
> -Wmissing-format-attribute -Woverloaded-virtual -pedantic -Wno-long-long -Wno-variadic-macros -Wno-overlength-strings   -DHAVE_CONFIG_H -I. -I. -I../../gcc-10.3.0/gcc -I../../gcc-10.3.0/gcc/.
> -I../../gcc-10.3.0/gcc/../include -I../../gcc-10.3.0/gcc/../libcpp/include  -I../../gcc-10.3.0/gcc/../libdecnumber -I../../gcc-10.3.0/gcc/../libdecnumber/dpd -I../libdecnumber -I../../gcc-
> 10.3.0/gcc/../libbacktrace   -o tree-ssa-structalias.o -MT tree-ssa-structalias.o -MMD -MP -MF ./.deps/tree-ssa-structalias.TPo ../../gcc-10.3.0/gcc/tree-ssa-structalias.c
> during RTL pass: vartrack
> ../../gcc-10.3.0/gcc/tree-ssa-strlen.c: In function ‘void maybe_warn_overflow(gimple*, tree, const vr_values*, strinfo*, bool, bool)’:
> ../../gcc-10.3.0/gcc/tree-ssa-strlen.c:2336:1: internal compiler error: Segmentation fault
>  2336 | }
>       | ^
> Please submit a full bug report,
> with preprocessed source if appropriate.
> See <https://gcc.gnu.org/bugs/> for instructions.
> make[2]: *** [Makefile:1117: tree-ssa-strlen.o] Error 1

I built it a few times in recent days (from x86_64-linux) and did not
experience this bug (didn’t see it on ci.guix either).  So yes, maybe
it’s a non-deterministic bug?

Ludo’.